<?php 
/*
Plugin Name: Smart SEO Data CSV Import/Export - Yoast WooCommerce Addon
Plugin URI: http://twitter.com/freddielore
Description: Allows you to export and import WooCommerce GTIN data generated by Yoast WooCommerce
Version: 1.0.1
Author: Freddie Lore
Author URI: http://twitter.com/freddielore
*/

if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly
}


/***----------- START: Export Yoast GTIN Data */
add_filter( 'smart_seo_export_fields', 'demo_export_yoast_gtin_data', 8, 1 );
function demo_export_yoast_gtin_data( $fields ){

	$fields[] = array( 'gtin8', 'demo_get_gtin8' ); 
	$fields[] = array( 'gtin12', 'demo_get_gtin12' );
	$fields[] = array( 'gtin13', 'demo_get_gtin13' );
	$fields[] = array( 'gtin14', 'demo_get_gtin14' );
	$fields[] = array( 'isbn', 'demo_get_isbn' );
	$fields[] = array( 'mpn', 'demo_get_mpn' );

	return $fields;
}

function demo_get_gtin8( $post ){

	$yoast_gtin_data = ( $post->post_type == 'product_variation' ) ? get_post_meta( $post->ID, 'wpseo_variation_global_identifiers_values', true ) : get_post_meta( $post->ID, 'wpseo_global_identifier_values', true );
	
	$yoast_gtin_data = maybe_unserialize( $yoast_gtin_data );
	return $yoast_gtin_data['gtin8']; 
}

function demo_get_gtin12( $post ){
	$yoast_gtin_data = ( $post->post_type == 'product_variation' ) ? get_post_meta( $post->ID, 'wpseo_variation_global_identifiers_values', true ) : get_post_meta( $post->ID, 'wpseo_global_identifier_values', true );
	$yoast_gtin_data = maybe_unserialize( $yoast_gtin_data );
	return $yoast_gtin_data['gtin12']; 
}

function demo_get_gtin13( $post ){
	$yoast_gtin_data = ( $post->post_type == 'product_variation' ) ? get_post_meta( $post->ID, 'wpseo_variation_global_identifiers_values', true ) : get_post_meta( $post->ID, 'wpseo_global_identifier_values', true );
	$yoast_gtin_data = maybe_unserialize( $yoast_gtin_data );
	return $yoast_gtin_data['gtin13']; 
}


function demo_get_gtin14( $post ){
	$yoast_gtin_data = ( $post->post_type == 'product_variation' ) ? get_post_meta( $post->ID, 'wpseo_variation_global_identifiers_values', true ) : get_post_meta( $post->ID, 'wpseo_global_identifier_values', true );
	$yoast_gtin_data = maybe_unserialize( $yoast_gtin_data );
	return $yoast_gtin_data['gtin14']; 
}

function demo_get_isbn( $post ){
	$yoast_gtin_data = ( $post->post_type == 'product_variation' ) ? get_post_meta( $post->ID, 'wpseo_variation_global_identifiers_values', true ) : get_post_meta( $post->ID, 'wpseo_global_identifier_values', true );
	$yoast_gtin_data = maybe_unserialize( $yoast_gtin_data );
	return $yoast_gtin_data['isbn']; 
}

function demo_get_mpn( $post ){
	$yoast_gtin_data = ( $post->post_type == 'product_variation' ) ? get_post_meta( $post->ID, 'wpseo_variation_global_identifiers_values', true ) : get_post_meta( $post->ID, 'wpseo_global_identifier_values', true );
	$yoast_gtin_data = maybe_unserialize( $yoast_gtin_data );
	return $yoast_gtin_data['mpn']; 
}


add_action( 'smart_seo_import_update', 'demo_import_yoast_gtin_data', 10, 3 );
function demo_import_yoast_gtin_data($post_id, $data, $headings){
	
	$yoast_gtin = array( 
		'gtin8' => $data['gtin8'],
		'gtin12' => $data['gtin12'],
		'gtin13' => $data['gtin13'],
		'gtin14' => $data['gtin14'],
		'isbn' => $data['isbn'],
		'mpn' => $data['mpn']
	);

	if( $data['post_type'] == 'product' ){
		update_post_meta( $post_id, 'wpseo_global_identifier_values', $yoast_gtin );
	}
	if( $data['post_type'] == 'product_variation' ){
		update_post_meta( $post_id, 'wpseo_variation_global_identifiers_values', $yoast_gtin );
	}
	
}
/***----------- END: Export Yoast GTIN Data */